<template>
    <div id="comments-container" class="d-flex">
        <div v-for="comment,index in allComments" v-bind:key='comment.id' id="comments">
            <div id="author" class="d-flex justify-content-between">
                <div class="d-flex">
                    <img v-bind:src="comment.User.image" id="user-img" v-bind:alt='"Photo de profil de " + comment.User.firstname + " " + comment.User.lastname'>
                    <div class="align-self-center">
                        <p id="user-name" class="text-start my-0 little-font font-weight-bold">{{ comment.User.firstname }}
                            {{ comment.User.lastname }}</p>
                        <p id="post-created-at" class="text-start my-0 very-small-font">le {{formattedDate(index)}}</p>
                    </div>
                    
                </div>
                <div id="edit-delete-icons" class="mx-2 my-2">
                        <button class="btn-modify align-middle" @click="editComment(comment)" v-if="comment.UserId === currentUserId" aria-label="Editer le commentaire">
                            <i v-bind:class="iconeEdit.icon" class="fas fa-edit"></i>
                        </button>
                        <button class="btn-modify align-middle" @click="deleteComment(comment)" v-if="canEdit(comment)" aria-label="Supprimer le commentaire">
                            <i class="fas fa-trash-alt"></i>
                        </button>
                        <!-- <edit-modale v-if="modaleEdit && postIndex == index"></edit-modale> -->
                    </div>
            </div>
            <div>
                <p class="little-font text-start mx-4 mb-1">{{comment.message}}</p>
                <div class="d-flex justify-content-between" v-if="isOpen && comment.UserId == currentUserId">
                    <input v-if="isOpen && commentIndex == index"  type="text" class="little-font" v-model="form.message" id="update-comment" aria-label="Modifer le commentaire">
                    <button v-if="isOpen && commentIndex == index" @click="sendEditComment(comment)" class="btn btn-modify mx-2 my-2" aria-label="Enregistrer les modifications">
                        <i class="fas fa-check-circle"></i>
                    </button>
                </div>
            </div>
            <div class="pb-3" v-if="isDeleteOpen && commentIndex == index">
                <p class="little-font">Voulez-vous vraiment supprimer ce commentaire?</p>
                <button @click="sendDeleteComment(comment)" class="btn btn-danger mx-3 px-2 py-0 little-font" aria-label="Supprimer le commentaire">Oui</button>
                <button @click="isDeleteOpen = false" class="btn btn-connexion mx-3 px-2 py-0 text-light little-font" aria-label="Ne pas supprimer le commentaire"> Non</button>
            </div>
        </div>
    </div>
</template>
<script>
    export default {
        data() {
            return {
                name: 'CommentsContainer',
                allComments: [],
                currentUserId:'',
                currentUserIsAdmin:false,
                changedIcon: false,
                commentIndex:null,
                form:{
                    message:'',
                    UserId:this.currentUserId,
                    PostId:this.PostId
                },
                isOpen:false,
                isDeleteOpen:false,
            }
        },
        computed: 
        {
            iconeEdit() {
            const iconeToShow = {
                icon: "fas fa-edit"
            }
            if (this.changedIcon) {
                iconeToShow.icon = "fas fa-times"
            }
            else if(!this.changedIcon)
            {
                iconeToShow.icon = "fas fa-edit"
            }
            return iconeToShow
            },
        },
        props: ["PostId", "UserId"],
        created() {
            this.getPost()
            this.getCurrentUser()
        },
        methods: {
            getCurrentUser(){
                const jwt = require('jsonwebtoken')
                const token = JSON.parse(localStorage.getItem('token'))
                const decodedToken = jwt.verify(token, 'RANDOM_TOKEN_SECRET');
                const userId = decodedToken.userId;
                const isAdmin  = decodedToken.isAdmin
                this.currentUserId = userId
                this.currentUserIsAdmin = isAdmin
            },
            canEdit(comment){
                // //console.log(comment.UserId,this.currentUserId);
                if (comment.UserId === this.currentUserId || this.currentUserIsAdmin) {
                    return true
                }else{
                    return false
                }
            },
            getPost() {
                const axios = require('axios')
                const url = `http://localhost:3000/api/posts/${this.PostId}`
                axios.get(url)
                    .then(res => {
                        //console.log(res.data);
                        this.allComments = res.data.Comments
                    })
            },
            formattedDate(index) {
                const element = this.allComments[index].createdAt
                const formattedDate = element.split('T').join((' à '))
                const formattedHour = formattedDate.split(':')
                return formattedHour[0] + 'h' + formattedHour[1]
            },
            editComment(comment) {
                this.form.message = comment.message
                this.changedIcon = !this.changedIcon
                this.commentIndex = this.allComments.findIndex(commentToCheck => commentToCheck === comment)
                this.isOpen = !this.isOpen
            },
            sendEditComment(comment){
                const axios = require('axios')
                const url = `http://localhost:3000/api/comments/update/${comment.id}`
                const data = {
                    message:this.form.message,
                    UserId: this.currentUserId,
                    PostId:this.PostId
                }
                //console.log(data);
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                        headers: {
                            'Authorization': `Bearer ${token}`
                        }
                    }
                axios.put(url,data,config)
                .then(res => {
                    console.log(res)
                    location.reload()
                })
                .catch(err => console.log(err))
            },
            deleteComment(comment){
                this.isDeleteOpen = !this.isDeleteOpen
                this.commentIndex = this.allComments.findIndex(commentToCheck => commentToCheck === comment)
                this.isOpen = false
                this.changedIcon= false
            },
            sendDeleteComment(comment){
                const axios = require('axios')
                const url = `http://localhost:3000/api/comments/delete/${comment.id}`
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                axios.delete(url,config)
                .then(res => {
                    console.log(res)
                    this.getPost()
                })
            }
        }
    }
</script>
<style scoped src="./CommentsContainer.css">

</style>